using JiShe.CollectBus.Common.Consts;
using JiShe.CollectBus.Common.Enums;
using JiShe.CollectBus.Common.Extensions;
using JiShe.CollectBus.IotSystems.Ammeters;
using JiShe.CollectBus.IotSystems.Devices;
using JiShe.CollectBus.Protocol.Contracts.Protocol.Dto;
using JiShe.CollectBus.Protocol.Dto;
using JiShe.CollectBus.Protocol.Interfaces;
using JiShe.CollectBus.Protocol.T37612012.Appendix;
using JiShe.CollectBus.Protocol3761;
using Microsoft.Extensions.Logging;
using System.Collections.Generic;

namespace JiShe.CollectBus.Protocol.T37612012.AnalysisData.AFN_0DH
{
    /// <summary>
    /// 5.13.2.4.116 F161：日冻结正向有功电能示值（总、费率 1～M）
    /// </summary>
    public class AFN13_F161_Analysis : IAnalysisStrategy<TB3761>
    {
        private readonly ILogger<AFN13_F161_Analysis> _logger;
        private readonly AnalysisStrategyContext _analysisStrategyContext;
        private readonly DataStorage _dataStorage;
        public AFN13_F161_Analysis(ILogger<AFN13_F161_Analysis> logger, AnalysisStrategyContext analysisStrategyContext, DataStorage dataStorage)
        {
            _logger = logger;
            _analysisStrategyContext = analysisStrategyContext;
            _dataStorage = dataStorage;
        }

        public async Task<bool> ExecuteAsync(TB3761 input, Action<dynamic>? result = null)
        {
            try
            {
                ArgumentNullException.ThrowIfNull(input);
                ArgumentNullException.ThrowIfNull(input.A.Code);
                ArgumentNullException.ThrowIfNull(input.UnitData?.HexMessageList);

                List<string> datas = await AnalysisDataUnitAsync(input.UnitData.HexMessageList);
                string timeSpan = $"{datas[0].Substring(0, 4)}-{datas[0].Substring(4, 2)}-{datas[0].Substring(6, 2)} 00:00:00";
                string dataType = $"{input.AFN_FC.AFN.HexToDecStr().PadLeft(2, '0')}_{input.DT.Fn}";

                List<AnalysisBaseDto<decimal?>> list = datas.GenerateFinalResultTd_d(3, dataType,timeSpan, "正向有功总电能示值").IsValidData(new List<string>() { "0D_161", "0D_161_1", "0D_161_2", "0D_161_3", "0D_161_4" });

                if (list.Count > 0)
                {
                    // 查询设备信息
                    DeviceCacheInfo? deviceInfo = await _dataStorage.GetDeviceInfoAsync(input.A.Code, input.DA.Pn);
                    if (deviceInfo != null)
                    {
                        list.ForEach(item =>
                        {
                            item.ProjectId = deviceInfo.ProjectId;
                            item.DeviceId = deviceInfo.MeterId;
                            item.DatabaseBusiID = deviceInfo.DatabaseBusiID;
                            item.DeviceAddress = deviceInfo.MeterAddress;
                            item.FocusId = deviceInfo.FocusId;
                        });
                    }
                }
                UnitDataAnalysis<List<AnalysisBaseDto<decimal?>>> unitDataAnalysis = new UnitDataAnalysis<List<AnalysisBaseDto<decimal?>>>
                {
                    Code = input.A.Code!,
                    AFN = input.AFN_FC.AFN,
                    Fn = input.DT.Fn,
                    Pn = input.DA.Pn,
                    MSA = input.A.A3!.D1_D7!,
                    PSEQ = input.SEQ.PSEQ,
                    Data = list,
                    ReceivedHexMessage = input.BaseHexMessage.HexMessageString,
                    MessageId = input.MessageId,
                    TimeDensity = 1,//密度-间隔,
                    DensityUnit = DensityUnit.Day,
                    ReceivedTime = input.ReceivedTime,
                    DataType = IOTDBDataTypeConst.Data,
                };
                await _dataStorage.SaveMultipleDataToIotDbAsync<decimal?>(unitDataAnalysis);
                result?.Invoke(unitDataAnalysis);
                return await Task.FromResult(true);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, $"0D_161解析失败:{input.A.Code}-{input.DT.Fn}-{input.BaseHexMessage.HexMessageString},{ex.Message}");
                return await Task.FromResult(false);
            }
        }

       
        private async Task<List<string>> AnalysisDataUnitAsync(List<string> hexMessageList)
        {
            List<string> values = new List<string>
            {
                hexMessageList.GetReadTime(4, 3),
                hexMessageList.GetReadTime(7, 5)
            };
            int ratingCount = hexMessageList.GetRatingCount(12, 1);
            values.Add(ratingCount.ToString());
            for (int i = 0; i < ratingCount + 1; i++)
            {
                var arr = hexMessageList.GetRange(13 + (i * 5), 5);
                var errorCode = arr.CheckErrorCode();
                if (errorCode != null)
                    values.Add(errorCode.Item1);
                else
                {
                    await _analysisStrategyContext.ExecuteAsync<List<string>>(nameof(Appendix_A14), arr, (value) =>
                    {
                        values.Add(value.ToString());
                    });
                }
            }
            return values;
        }
    }
}
